/* Multiple-precision global reductions.			*/
/* Source file:  miglob.cs		Header file:  miglob.h	*/
/* Ernest Sibert - July 1995					*/

#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <cscomm.h>
#include "pmiarith.h"
#include "multip.h"

/* Global minimum:  d[0..N] := (<?= X[0..N]).  Call from 1-D shape.	*/

void imglbmin( int d[], int:current X[], int N)
 { int:current I, *W, *Y;	/* Working arrays for calculation */
   int nb;
   I = pcoord(0);  nb = (N+1)*boolsizeof(int:current);
   W = palloc(current, nb);  Y = palloc(current, nb);
   if ( (W == NULL) || (Y == NULL) )
    { printf("Out of CM memory in imglbmin\n");  d[0] = Ovflw;  return; }
   else
    { int csz, k, msk, u;
      everywhere /* Quick and dirty maximum integer */
       { W[0] = 4;  for ( k = 1;  k <= N;  k++ )  W[k] = 0x3fffffff; }
      pmcopy(W, X, N);
      csz = positionsof(current);
/* printf("Proc            W                       Y      Size: %d\n", csz); */
      everywhere	/* Reduction loop */
       { for ( k = 1, msk = 1;  k < csz;  k <<= 1, msk |= (msk < 1) )
          where ( (I + k < csz) & ((I&msk) == 0) )
           { from_torus_dim(Y, W, nb, 0, k);
	    /* for ( u = 0;  u < csz; u++ )
	       printf("%4d  0x%08x 0x%08x   0x%08x 0x%08x\n",
		         u, [u]W[0],[u]W[N],[u]Y[0],[u]Y[N]  ); */
             where (pimcomp(W,Y,N) == 1) pmcopy(W,Y,N);}
         pmp2mp(d, W, N, 0); 
       }
     }
   pfree(W);  pfree(Y);
 }
